"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.overlaysResults = void 0;
const lang_1 = require("../lang");
const single_overlay_content_1 = require("./single-overlay-content");
/**
 * Interface representing the result of processing a Kustomize overlay
 * @interface OverlayResult
 * @property {string} overlay - The path to the overlay directory relative to the base
 * @property {string} content - The raw YAML content generated from building the overlay
 */
const overlaysResults = (overlayResults) => {
    return (0, lang_1.trimIndent)(`|{{- define "yamls" }}
        |{{- if .Values.overlay }}
        |${overlayResults
        .map(({ overlay, content }) => (0, single_overlay_content_1.singleOverlay)(overlay, content))
        .join('\n')}
        |{{- else }}
        |manifests: []
        |{{- end }}{{- end }}`);
};
exports.overlaysResults = overlaysResults;
