"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.fsDefault = void 0;
exports.groupBy = groupBy;
exports.randomString = randomString;
const fsDefaultInternal = __importStar(require("fs"));
/**
 * Groups an array of items by a key derived from each item.
 * @template T The type of items in the input array
 * @template K The type of the grouping key
 * @param list - The array of items to group
 * @param keyGetter - A function that extracts the grouping key from an item
 * @returns A Map where each key maps to an array of items that share that key
 * @example
 * const people = [{name: 'Alice', age: 21}, {name: 'Bob', age: 21}];
 * const byAge = groupBy(people, p => p.age);
 * // Map { 21 => [{name: 'Alice', age: 21}, {name: 'Bob', age: 21}] }
 */
function groupBy(list, keyGetter) {
    return list.reduce((map, item) => {
        const key = keyGetter(item);
        const collection = map.get(key) || [];
        collection.push(item);
        map.set(key, collection);
        return map;
    }, new Map());
}
/**
 * Generates a random string using base-36 encoding.
 * @returns A random string containing alphanumeric characters
 * @example
 * const id = randomString(); // e.g. "x7hq9w"
 */
function randomString() {
    return Math.random().toString(36).substring(2, 36);
}
exports.fsDefault = fsDefaultInternal;
